/* tslint:disable */
/* eslint-disable */
/**
 * Coscine.Api.STS
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 0.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import type { Configuration } from '../../configuration';
import type { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import globalAxios from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError, operationServerMap } from '../../base';
/**
 * ORCiDApi - axios parameter creator
 * @export
 */
export const ORCiDApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary ORCiD Login Route
         * @param {string | null} [returnUrl] URL to be redirected to
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        oRCiDLoginGET: async (returnUrl?: string | null, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/ORCiD/login`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication JWT token required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)

            if (returnUrl !== undefined) {
                localVarQueryParameter['returnUrl'] = returnUrl;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Execute ORCiD validation and login
         * @param {string | null} [oRCiDJWT] 
         * @param {string | null} [returnUrl] URL to be redirected to
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        oRCiDLoginPOST: async (oRCiDJWT?: string | null, returnUrl?: string | null, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/ORCiD/login`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication JWT token required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)

            if (oRCiDJWT !== undefined) {
                localVarQueryParameter['ORCiD_JWT'] = oRCiDJWT;
            }

            if (returnUrl !== undefined) {
                localVarQueryParameter['returnUrl'] = returnUrl;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * ORCiDApi - functional programming interface
 * @export
 */
export const ORCiDApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = ORCiDApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary ORCiD Login Route
         * @param {string | null} [returnUrl] URL to be redirected to
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async oRCiDLoginGET(returnUrl?: string | null, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<File>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.oRCiDLoginGET(returnUrl, options);
            const index = configuration?.serverIndex ?? 0;
            const operationBasePath = operationServerMap['ORCiDApi.oRCiDLoginGET']?.[index]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, operationBasePath || basePath);
        },
        /**
         * 
         * @summary Execute ORCiD validation and login
         * @param {string | null} [oRCiDJWT] 
         * @param {string | null} [returnUrl] URL to be redirected to
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async oRCiDLoginPOST(oRCiDJWT?: string | null, returnUrl?: string | null, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<File>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.oRCiDLoginPOST(oRCiDJWT, returnUrl, options);
            const index = configuration?.serverIndex ?? 0;
            const operationBasePath = operationServerMap['ORCiDApi.oRCiDLoginPOST']?.[index]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, operationBasePath || basePath);
        },
    }
};

/**
 * ORCiDApi - factory interface
 * @export
 */
export const ORCiDApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = ORCiDApiFp(configuration)
    return {
        /**
         * 
         * @summary ORCiD Login Route
         * @param {ORCiDApiORCiDLoginGETRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        oRCiDLoginGET(requestParameters: ORCiDApiORCiDLoginGETRequest = {}, options?: AxiosRequestConfig): AxiosPromise<File> {
            return localVarFp.oRCiDLoginGET(requestParameters.returnUrl, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Execute ORCiD validation and login
         * @param {ORCiDApiORCiDLoginPOSTRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        oRCiDLoginPOST(requestParameters: ORCiDApiORCiDLoginPOSTRequest = {}, options?: AxiosRequestConfig): AxiosPromise<File> {
            return localVarFp.oRCiDLoginPOST(requestParameters.oRCiDJWT, requestParameters.returnUrl, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for oRCiDLoginGET operation in ORCiDApi.
 * @export
 * @interface ORCiDApiORCiDLoginGETRequest
 */
export interface ORCiDApiORCiDLoginGETRequest {
    /**
     * URL to be redirected to
     * @type {string}
     * @memberof ORCiDApiORCiDLoginGET
     */
    readonly returnUrl?: string | null
}

/**
 * Request parameters for oRCiDLoginPOST operation in ORCiDApi.
 * @export
 * @interface ORCiDApiORCiDLoginPOSTRequest
 */
export interface ORCiDApiORCiDLoginPOSTRequest {
    /**
     * 
     * @type {string}
     * @memberof ORCiDApiORCiDLoginPOST
     */
    readonly oRCiDJWT?: string | null

    /**
     * URL to be redirected to
     * @type {string}
     * @memberof ORCiDApiORCiDLoginPOST
     */
    readonly returnUrl?: string | null
}

/**
 * ORCiDApi - object-oriented interface
 * @export
 * @class ORCiDApi
 * @extends {BaseAPI}
 */
export class ORCiDApi extends BaseAPI {
    /**
     * 
     * @summary ORCiD Login Route
     * @param {ORCiDApiORCiDLoginGETRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ORCiDApi
     */
    public oRCiDLoginGET(requestParameters: ORCiDApiORCiDLoginGETRequest = {}, options?: AxiosRequestConfig) {
        return ORCiDApiFp(this.configuration).oRCiDLoginGET(requestParameters.returnUrl, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Execute ORCiD validation and login
     * @param {ORCiDApiORCiDLoginPOSTRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ORCiDApi
     */
    public oRCiDLoginPOST(requestParameters: ORCiDApiORCiDLoginPOSTRequest = {}, options?: AxiosRequestConfig) {
        return ORCiDApiFp(this.configuration).oRCiDLoginPOST(requestParameters.oRCiDJWT, requestParameters.returnUrl, options).then((request) => request(this.axios, this.basePath));
    }
}

